<?php
/**
 * OrderItem
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * OMS
 *
 * Управление заказами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\OmsClient\Dto;

use \ArrayAccess;
use \Ensi\OmsClient\ObjectSerializer;

/**
 * OrderItem Class Doc Comment
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class OrderItem implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'OrderItem';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'order_id' => 'int',
        'shipment_id' => 'int',
        'offer_id' => 'int',
        'name' => 'string',
        'qty' => 'float',
        'old_qty' => 'float',
        'price' => 'int',
        'price_per_one' => 'int',
        'cost' => 'int',
        'cost_per_one' => 'int',
        'product_weight' => 'float',
        'product_weight_gross' => 'float',
        'product_width' => 'float',
        'product_height' => 'float',
        'product_length' => 'float',
        'product_barcode' => 'string',
        'refund_qty' => 'float',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'is_added' => 'bool',
        'is_deleted' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'order_id' => null,
        'shipment_id' => null,
        'offer_id' => null,
        'name' => null,
        'qty' => null,
        'old_qty' => null,
        'price' => null,
        'price_per_one' => null,
        'cost' => null,
        'cost_per_one' => null,
        'product_weight' => null,
        'product_weight_gross' => null,
        'product_width' => null,
        'product_height' => null,
        'product_length' => null,
        'product_barcode' => null,
        'refund_qty' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'is_added' => null,
        'is_deleted' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'order_id' => false,
        'shipment_id' => false,
        'offer_id' => false,
        'name' => false,
        'qty' => false,
        'old_qty' => true,
        'price' => false,
        'price_per_one' => false,
        'cost' => false,
        'cost_per_one' => false,
        'product_weight' => false,
        'product_weight_gross' => false,
        'product_width' => false,
        'product_height' => false,
        'product_length' => false,
        'product_barcode' => true,
        'refund_qty' => true,
        'created_at' => false,
        'updated_at' => false,
        'is_added' => false,
        'is_deleted' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'order_id' => 'order_id',
        'shipment_id' => 'shipment_id',
        'offer_id' => 'offer_id',
        'name' => 'name',
        'qty' => 'qty',
        'old_qty' => 'old_qty',
        'price' => 'price',
        'price_per_one' => 'price_per_one',
        'cost' => 'cost',
        'cost_per_one' => 'cost_per_one',
        'product_weight' => 'product_weight',
        'product_weight_gross' => 'product_weight_gross',
        'product_width' => 'product_width',
        'product_height' => 'product_height',
        'product_length' => 'product_length',
        'product_barcode' => 'product_barcode',
        'refund_qty' => 'refund_qty',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'is_added' => 'is_added',
        'is_deleted' => 'is_deleted'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'order_id' => 'setOrderId',
        'shipment_id' => 'setShipmentId',
        'offer_id' => 'setOfferId',
        'name' => 'setName',
        'qty' => 'setQty',
        'old_qty' => 'setOldQty',
        'price' => 'setPrice',
        'price_per_one' => 'setPricePerOne',
        'cost' => 'setCost',
        'cost_per_one' => 'setCostPerOne',
        'product_weight' => 'setProductWeight',
        'product_weight_gross' => 'setProductWeightGross',
        'product_width' => 'setProductWidth',
        'product_height' => 'setProductHeight',
        'product_length' => 'setProductLength',
        'product_barcode' => 'setProductBarcode',
        'refund_qty' => 'setRefundQty',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'is_added' => 'setIsAdded',
        'is_deleted' => 'setIsDeleted'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'order_id' => 'getOrderId',
        'shipment_id' => 'getShipmentId',
        'offer_id' => 'getOfferId',
        'name' => 'getName',
        'qty' => 'getQty',
        'old_qty' => 'getOldQty',
        'price' => 'getPrice',
        'price_per_one' => 'getPricePerOne',
        'cost' => 'getCost',
        'cost_per_one' => 'getCostPerOne',
        'product_weight' => 'getProductWeight',
        'product_weight_gross' => 'getProductWeightGross',
        'product_width' => 'getProductWidth',
        'product_height' => 'getProductHeight',
        'product_length' => 'getProductLength',
        'product_barcode' => 'getProductBarcode',
        'refund_qty' => 'getRefundQty',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'is_added' => 'getIsAdded',
        'is_deleted' => 'getIsDeleted'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('order_id', $data, null);
        $this->setIfExists('shipment_id', $data, null);
        $this->setIfExists('offer_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('qty', $data, null);
        $this->setIfExists('old_qty', $data, null);
        $this->setIfExists('price', $data, null);
        $this->setIfExists('price_per_one', $data, null);
        $this->setIfExists('cost', $data, null);
        $this->setIfExists('cost_per_one', $data, null);
        $this->setIfExists('product_weight', $data, null);
        $this->setIfExists('product_weight_gross', $data, null);
        $this->setIfExists('product_width', $data, null);
        $this->setIfExists('product_height', $data, null);
        $this->setIfExists('product_length', $data, null);
        $this->setIfExists('product_barcode', $data, null);
        $this->setIfExists('refund_qty', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('is_added', $data, null);
        $this->setIfExists('is_deleted', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['order_id'] === null) {
            $invalidProperties[] = "'order_id' can't be null";
        }
        if ($this->container['shipment_id'] === null) {
            $invalidProperties[] = "'shipment_id' can't be null";
        }
        if ($this->container['offer_id'] === null) {
            $invalidProperties[] = "'offer_id' can't be null";
        }
        if ($this->container['name'] === null) {
            $invalidProperties[] = "'name' can't be null";
        }
        if ($this->container['qty'] === null) {
            $invalidProperties[] = "'qty' can't be null";
        }
        if ($this->container['price'] === null) {
            $invalidProperties[] = "'price' can't be null";
        }
        if ($this->container['price_per_one'] === null) {
            $invalidProperties[] = "'price_per_one' can't be null";
        }
        if ($this->container['cost'] === null) {
            $invalidProperties[] = "'cost' can't be null";
        }
        if ($this->container['cost_per_one'] === null) {
            $invalidProperties[] = "'cost_per_one' can't be null";
        }
        if ($this->container['product_weight'] === null) {
            $invalidProperties[] = "'product_weight' can't be null";
        }
        if ($this->container['product_weight_gross'] === null) {
            $invalidProperties[] = "'product_weight_gross' can't be null";
        }
        if ($this->container['product_width'] === null) {
            $invalidProperties[] = "'product_width' can't be null";
        }
        if ($this->container['product_height'] === null) {
            $invalidProperties[] = "'product_height' can't be null";
        }
        if ($this->container['product_length'] === null) {
            $invalidProperties[] = "'product_length' can't be null";
        }
        if ($this->container['product_barcode'] === null) {
            $invalidProperties[] = "'product_barcode' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id id элемента корзины
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets order_id
     *
     * @return int
     */
    public function getOrderId()
    {
        return $this->container['order_id'];
    }

    /**
     * Sets order_id
     *
     * @param int $order_id ID заказа
     *
     * @return $this
     */
    public function setOrderId($order_id)
    {


        /*if (is_null($order_id)) {
            throw new \InvalidArgumentException('non-nullable order_id cannot be null');
        }*/
        $this->container['order_id'] = $order_id;

        return $this;
    }

    /**
     * Gets shipment_id
     *
     * @return int
     */
    public function getShipmentId()
    {
        return $this->container['shipment_id'];
    }

    /**
     * Sets shipment_id
     *
     * @param int $shipment_id ID отгрузки
     *
     * @return $this
     */
    public function setShipmentId($shipment_id)
    {


        /*if (is_null($shipment_id)) {
            throw new \InvalidArgumentException('non-nullable shipment_id cannot be null');
        }*/
        $this->container['shipment_id'] = $shipment_id;

        return $this;
    }

    /**
     * Gets offer_id
     *
     * @return int
     */
    public function getOfferId()
    {
        return $this->container['offer_id'];
    }

    /**
     * Sets offer_id
     *
     * @param int $offer_id ID оффера
     *
     * @return $this
     */
    public function setOfferId($offer_id)
    {


        /*if (is_null($offer_id)) {
            throw new \InvalidArgumentException('non-nullable offer_id cannot be null');
        }*/
        $this->container['offer_id'] = $offer_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Название товара
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets qty
     *
     * @return float
     */
    public function getQty()
    {
        return $this->container['qty'];
    }

    /**
     * Sets qty
     *
     * @param float $qty Кол-во товара
     *
     * @return $this
     */
    public function setQty($qty)
    {


        /*if (is_null($qty)) {
            throw new \InvalidArgumentException('non-nullable qty cannot be null');
        }*/
        $this->container['qty'] = $qty;

        return $this;
    }

    /**
     * Gets old_qty
     *
     * @return float|null
     */
    public function getOldQty()
    {
        return $this->container['old_qty'];
    }

    /**
     * Sets old_qty
     *
     * @param float|null $old_qty Старое кол-во товара
     *
     * @return $this
     */
    public function setOldQty($old_qty)
    {

        if (is_null($old_qty)) {
            array_push($this->openAPINullablesSetToNull, 'old_qty');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('old_qty', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['old_qty'] = $old_qty;

        return $this;
    }

    /**
     * Gets price
     *
     * @return int
     */
    public function getPrice()
    {
        return $this->container['price'];
    }

    /**
     * Sets price
     *
     * @param int $price Цена товара (цена * qty - скидки) (в коп.)
     *
     * @return $this
     */
    public function setPrice($price)
    {


        /*if (is_null($price)) {
            throw new \InvalidArgumentException('non-nullable price cannot be null');
        }*/
        $this->container['price'] = $price;

        return $this;
    }

    /**
     * Gets price_per_one
     *
     * @return int
     */
    public function getPricePerOne()
    {
        return $this->container['price_per_one'];
    }

    /**
     * Sets price_per_one
     *
     * @param int $price_per_one Цена единичного товара (в коп.)
     *
     * @return $this
     */
    public function setPricePerOne($price_per_one)
    {


        /*if (is_null($price_per_one)) {
            throw new \InvalidArgumentException('non-nullable price_per_one cannot be null');
        }*/
        $this->container['price_per_one'] = $price_per_one;

        return $this;
    }

    /**
     * Gets cost
     *
     * @return int
     */
    public function getCost()
    {
        return $this->container['cost'];
    }

    /**
     * Sets cost
     *
     * @param int $cost Цена товара до скидок (цена * qty) (в коп.)
     *
     * @return $this
     */
    public function setCost($cost)
    {


        /*if (is_null($cost)) {
            throw new \InvalidArgumentException('non-nullable cost cannot be null');
        }*/
        $this->container['cost'] = $cost;

        return $this;
    }

    /**
     * Gets cost_per_one
     *
     * @return int
     */
    public function getCostPerOne()
    {
        return $this->container['cost_per_one'];
    }

    /**
     * Sets cost_per_one
     *
     * @param int $cost_per_one Цена единичного товара до скидок (в коп.)
     *
     * @return $this
     */
    public function setCostPerOne($cost_per_one)
    {


        /*if (is_null($cost_per_one)) {
            throw new \InvalidArgumentException('non-nullable cost_per_one cannot be null');
        }*/
        $this->container['cost_per_one'] = $cost_per_one;

        return $this;
    }

    /**
     * Gets product_weight
     *
     * @return float
     */
    public function getProductWeight()
    {
        return $this->container['product_weight'];
    }

    /**
     * Sets product_weight
     *
     * @param float $product_weight Вес нетто товара (кг)
     *
     * @return $this
     */
    public function setProductWeight($product_weight)
    {


        /*if (is_null($product_weight)) {
            throw new \InvalidArgumentException('non-nullable product_weight cannot be null');
        }*/
        $this->container['product_weight'] = $product_weight;

        return $this;
    }

    /**
     * Gets product_weight_gross
     *
     * @return float
     */
    public function getProductWeightGross()
    {
        return $this->container['product_weight_gross'];
    }

    /**
     * Sets product_weight_gross
     *
     * @param float $product_weight_gross Вес брутто товара (кг)
     *
     * @return $this
     */
    public function setProductWeightGross($product_weight_gross)
    {


        /*if (is_null($product_weight_gross)) {
            throw new \InvalidArgumentException('non-nullable product_weight_gross cannot be null');
        }*/
        $this->container['product_weight_gross'] = $product_weight_gross;

        return $this;
    }

    /**
     * Gets product_width
     *
     * @return float
     */
    public function getProductWidth()
    {
        return $this->container['product_width'];
    }

    /**
     * Sets product_width
     *
     * @param float $product_width Ширина товара (мм)
     *
     * @return $this
     */
    public function setProductWidth($product_width)
    {


        /*if (is_null($product_width)) {
            throw new \InvalidArgumentException('non-nullable product_width cannot be null');
        }*/
        $this->container['product_width'] = $product_width;

        return $this;
    }

    /**
     * Gets product_height
     *
     * @return float
     */
    public function getProductHeight()
    {
        return $this->container['product_height'];
    }

    /**
     * Sets product_height
     *
     * @param float $product_height Высота товара (мм)
     *
     * @return $this
     */
    public function setProductHeight($product_height)
    {


        /*if (is_null($product_height)) {
            throw new \InvalidArgumentException('non-nullable product_height cannot be null');
        }*/
        $this->container['product_height'] = $product_height;

        return $this;
    }

    /**
     * Gets product_length
     *
     * @return float
     */
    public function getProductLength()
    {
        return $this->container['product_length'];
    }

    /**
     * Sets product_length
     *
     * @param float $product_length Длина товара (мм)
     *
     * @return $this
     */
    public function setProductLength($product_length)
    {


        /*if (is_null($product_length)) {
            throw new \InvalidArgumentException('non-nullable product_length cannot be null');
        }*/
        $this->container['product_length'] = $product_length;

        return $this;
    }

    /**
     * Gets product_barcode
     *
     * @return string|null
     */
    public function getProductBarcode()
    {
        return $this->container['product_barcode'];
    }

    /**
     * Sets product_barcode
     *
     * @param string|null $product_barcode артикул (EAN)
     *
     * @return $this
     */
    public function setProductBarcode($product_barcode)
    {

        if (is_null($product_barcode)) {
            array_push($this->openAPINullablesSetToNull, 'product_barcode');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('product_barcode', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['product_barcode'] = $product_barcode;

        return $this;
    }

    /**
     * Gets refund_qty
     *
     * @return float|null
     */
    public function getRefundQty()
    {
        return $this->container['refund_qty'];
    }

    /**
     * Sets refund_qty
     *
     * @param float|null $refund_qty Количество возвращаемых элементов корзины в заявке
     *
     * @return $this
     */
    public function setRefundQty($refund_qty)
    {

        if (is_null($refund_qty)) {
            array_push($this->openAPINullablesSetToNull, 'refund_qty');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('refund_qty', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['refund_qty'] = $refund_qty;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets is_added
     *
     * @return bool|null
     */
    public function getIsAdded()
    {
        return $this->container['is_added'];
    }

    /**
     * Sets is_added
     *
     * @param bool|null $is_added флаг, что товар был добавлен
     *
     * @return $this
     */
    public function setIsAdded($is_added)
    {


        /*if (is_null($is_added)) {
            throw new \InvalidArgumentException('non-nullable is_added cannot be null');
        }*/
        $this->container['is_added'] = $is_added;

        return $this;
    }

    /**
     * Gets is_deleted
     *
     * @return bool|null
     */
    public function getIsDeleted()
    {
        return $this->container['is_deleted'];
    }

    /**
     * Sets is_deleted
     *
     * @param bool|null $is_deleted флаг, что товар был удалён
     *
     * @return $this
     */
    public function setIsDeleted($is_deleted)
    {


        /*if (is_null($is_deleted)) {
            throw new \InvalidArgumentException('non-nullable is_deleted cannot be null');
        }*/
        $this->container['is_deleted'] = $is_deleted;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


